%% parameters
step_down = 900;
step_up = 1500;
% Mud properties
 PV = 16.0e-3*10^-5;     % [Bar*s]
 YP = 7.5e-5;            % [Bar]
 YP1 = 40.5e-5;          % [Bar]
 
 % For Cheng model
 a = 1e-3;               % [1/s]
 b = 1.44e-5;
 lambda_init = 0.8;        % varies from 0 to 1

% Conversion factors
inperm = 1/2.54e-2;      % inches per meter
lmptom3pers = 1/(60*1000);
lbperkg = 1/453.59237e-3;
barperpsi = 6.894757/100;
galperm3 = 1/3.785412e-3;

% Constants
Md = 6000;               % [bar s2 m2]
Ma = 1600;               % [bar s2 m2]

beta_d = 15000;          % [bar]
beta_a = 15000;          % [bar] %500?

rhoH2O = 1000;
g = 9.81;
sg = 1.18;
rho_m = sg*rhoH2O;       %[kg/m^3]
p_s = 1;                 % [bar]

% Volumes
%d_i = (4+8/29)/inperm;
d_i = 0.1086;            % [m]
d_o = 0.1270;            % [m]
d_h = 0.2454;            % [m]
A_a = pi*(d_h-d_o);       % [m^2]
L_d = 4019;              % [m]
%L_a = 4000;              % [m]
L_a = 1826;              % [m] Vertical depth

V_d = (pi/4)*d_i^2*L_d;
V_a = (pi/4)*(d_h^2-d_o^2)*L_a;

% Choke
u_0 = 29.2;
u_max = 42.7;
C_v = 41;
p_c_ref = 14.1;           % [barg]
k = 0.0865;

% Flow from pump
m3ps = 1/(1000*60);  % to have m3 per sec instead of l per min
qTrouble = 100*m3ps;
p_dh_ref = 200;      % [bar]

% shear stress
p_p_ss = 188.8;     % [bar]
q_b_ss = 2000;      % [lmp]

f = p_p_ss/((q_b_ss*lmptom3pers)^2);

%Other friction losses
Cb = 0.98;
A = (pi/4)*(15^2 + 15^2 + 16^2 + 16^2)/32^2/inperm^2;
Csc = 0.5;  % A number between 0.15 and 1

K_lqr=-2.83;